import _extends from "@babel/runtime/helpers/esm/extends";
import { useReducer } from 'react';
var usePasswordChangeFormState = function usePasswordChangeFormState() {
  var initialState = {
    newPassword: '',
    repeatPassword: '',
    isLoading: false,
    notification: {
      text: '',
      isError: false
    }
  };
  var reducer = function reducer(state, action) {
    switch (action.type) {
      case 'SET_NEW_PASSWORD':
        return _extends({}, state, {
          newPassword: action.payload,
          isLoading: false
        });
      case 'SET_REPEAT_PASSWORD':
        return _extends({}, state, {
          repeatPassword: action.payload,
          isLoading: false
        });
      case 'SET_NOTIFICATION':
        return _extends({}, state, {
          notification: {
            text: action.payload.text,
            isError: action.payload.isError
          },
          isLoading: false
        });
      case 'SET_LOADING':
        return _extends({}, state, {
          isLoading: action.payload
        });
      default:
        return state;
    }
  };
  var _useReducer = useReducer(reducer, initialState),
    state = _useReducer[0],
    dispatch = _useReducer[1];

  // Action for each of the above
  var setNewPassword = function setNewPassword(newPassword) {
    dispatch({
      type: 'SET_NEW_PASSWORD',
      payload: newPassword
    });
  };
  var setRepeatPassword = function setRepeatPassword(repeatPassword) {
    dispatch({
      type: 'SET_REPEAT_PASSWORD',
      payload: repeatPassword
    });
  };
  var setNotification = function setNotification(_ref) {
    var text = _ref.text,
      isError = _ref.isError;
    dispatch({
      type: 'SET_NOTIFICATION',
      payload: {
        text: text,
        isError: isError
      }
    });
  };
  var setIsLoading = function setIsLoading(isLoading) {
    dispatch({
      type: 'SET_LOADING',
      payload: isLoading
    });
  };
  return {
    state: state,
    setNewPassword: setNewPassword,
    setRepeatPassword: setRepeatPassword,
    setNotification: setNotification,
    setIsLoading: setIsLoading
  };
};
export default usePasswordChangeFormState;